package org.netkernel.xml.accessor.schema;

import org.netkernel.layer0.meta.impl.SourcedArgumentMetaImpl;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.xml.accessor.xslt.RepXSLTransformer;
import org.netkernel.xml.xda.DOMXDA;
import org.w3c.dom.Document;

public class XPathEvalAccessor extends StandardAccessorImpl
{	
	public XPathEvalAccessor()
	{	this.declareThreadSafe();
		this.declareSourceRepresentation(Boolean.class);
		declareArgument(new SourcedArgumentMetaImpl("operator",null,null,new Class[] {String.class}));
		declareArgument(new SourcedArgumentMetaImpl("operand",null,null,new Class[] {Document.class}));
	}

	@Override
	public void onSource(INKFRequestContext context) throws Exception
	{	String xpath=(String)context.source("arg:operator", String.class);
		Document doc=(Document)context.source("arg:operand", Document.class);
		DOMXDA xda=new DOMXDA(doc, false);
		context.createResponseFrom(xda.isTrue(xpath));
	}
}
